
<template>
  <section changes>
    <template v-if="changeCount === 0">
      <section empty>
        <md-icon md-src="/img/md/inbox.svg"/>
        <h1>No changes pending</h1>
        <p>
          When editing keys in the L1CE editor, your changes will be kept here. <br>
          You will be able to inspect your changes and choose to either permanently commit or discard them.
        </p>
      </section>
    </template>
    <template v-else>
      <section changelist>
        <ul>
          <li v-for="(change, index) in store.get.database('mychanges')" :key="index" @click="selectedChange = change">
            <table>
              <tr><td>{{changeText(change)}} in</td><td>{{change.tableName}}</td></tr>
              <tr><td>key name</td><td>{{change.keyName}}</td></tr>
              <tr v-if="change.sourceKeyName"><td>source key</td><td>{{change.sourceKeyName}}</td></tr>
            </table>
          </li>
        </ul>
        <div v-if="selectedChange" selectedchange>
          <p>{{selectedChange.tableName}}</p>
          <img v-if="loading" src="/img/hourglass_color.gif" alt="tick tock tick tock">
          <template v-else-if="diffData">
            <DiffRowEl v-for="diffRow in diffData.headers" :key="diffRow.columnName" :diffRow="diffRow"></DiffRowEl>
            <DiffRowEl v-for="diffRow in diffData.meta" :key="diffRow.columnName" :diffRow="diffRow"></DiffRowEl>
            <DiffRowEl v-for="diffRow in diffData.data" :key="diffRow.columnName" :diffRow="diffRow"></DiffRowEl>
          </template>
        </div>
      </section>
      <div commitbar>
        <md-button class="md-raised" @click="commit" commit >commit</md-button>
        <md-button class="md-raised" @click="rollback" discard >discard</md-button>
      </div>
    </template>
  </section>
</template>

<script lang="ts">
import { Component, Vue, Watch } from 'vue-property-decorator';
import { store } from '../store';
import { Change } from '../store/database';
import axios from '../lib/axios';
import { sortColumns, metaColumns } from '../lib/columnUtils';
import DiffRowEl from '../components/changes/diffRow.vue';
import { DiffData, getDiff } from '../lib/diffData';

@Component({
  components: {
    DiffRowEl,
  },
})
export default class extends Vue {

  private selectedChange: Change | null = null;

  private diffData: DiffData | null = null;

  private loading: boolean = false;

  get store() {
    return store;
  }

  get changeCount() {
    return store.get.database('mychanges').length;
  }

  private changeText(change: Change) {
    switch (change.type) {
      case 'new':
        return 'new key';
      case 'validation':
        return 'revalidation';
      case 'invalidation':
        return 'decommission';
      default:
        return change.type;
    }
  }

  @Watch('selectedChange')
  private async getRows() {
    const c = this.selectedChange;
    if (!c) {
      this.diffData = null;
    } else {
      this.loading = true;
      this.diffData = await getDiff(c.tableName, c.sourceKeyName, c.keyName);
      this.loading = false;
    }
  }

  private commit() {
    axios.post('/api/v0/db/changes/commit').then(() => store.dispatch.database('getChanges'));
  }

  private rollback() {
    axios.post('/api/v0/db/changes/rollback')
    .then(() => store.commit.database('clearCache'))
    .then(() => store.dispatch.database('getChanges'));
  }

}
</script>

<style scoped lang="scss">
[changes] {
  display: flex;
  flex-direction: column;
  height: 100%;

  [empty] {
    display: flex;
    flex-direction: column;
    align-items: center;
    justify-content: center;
    flex: 1;

    i {
      padding: 0;
      margin: 0;
      height: 100px;
      width: 100px;
    }
    p {
      text-align: center;
    }
  }

  [changelist] {
    display: flex;
    flex-direction: row;
    flex: 1;

    [selectedchange] {
      flex: 1;
    }

    ul {
      list-style: none;
      padding: 0;
      margin: 0;
      margin-right: 10px;

      li {
        border-bottom: 1px solid rgba(0, 0, 0, .2);
        padding: .5em;

        table {
          tr {
            &:first-child {
              font-weight: bold;
            }
          }
        }
      }
    }
  }

  [commitbar] {
    display: flex;
    justify-content: flex-end;

    .md-button {
      &[commit] {
        background: md-get-palette-color(red, 900);
        color: white;
      }
    }
  }
}
</style>
